package org.jeecg.modules.itdmWeituoChaXun.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.itdmWeituoChaXun.entity.ItdmWeituoYangpin;
import org.jeecg.modules.itdmWeituoChaXun.service.IItdmWeituoYangpinService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 委托样品
 * @Author: jeecg-boot
 * @Date:   2023-05-22
 * @Version: V1.0
 */
@Api(tags="委托样品")
@RestController
@RequestMapping("/itdmWeituoChaXun/itdmWeituoYangpin")
@Slf4j
public class ItdmWeituoYangpinController extends JeecgController<ItdmWeituoYangpin, IItdmWeituoYangpinService> {
	@Autowired
	private IItdmWeituoYangpinService itdmWeituoYangpinService;
	
	/**
	 * 分页列表查询
	 *
	 * @param itdmWeituoYangpin
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "委托样品-分页列表查询")
	@ApiOperation(value="委托样品-分页列表查询", notes="委托样品-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ItdmWeituoYangpin>> queryPageList(ItdmWeituoYangpin itdmWeituoYangpin,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<ItdmWeituoYangpin> queryWrapper = QueryGenerator.initQueryWrapper(itdmWeituoYangpin, req.getParameterMap());
		Page<ItdmWeituoYangpin> page = new Page<ItdmWeituoYangpin>(pageNo, pageSize);
		IPage<ItdmWeituoYangpin> pageList = itdmWeituoYangpinService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param itdmWeituoYangpin
	 * @return
	 */
	@AutoLog(value = "委托样品-添加")
	@ApiOperation(value="委托样品-添加", notes="委托样品-添加")
	//@RequiresPermissions("org.jeecg.modules:itdm_weituo_yangpin:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ItdmWeituoYangpin itdmWeituoYangpin) {
		itdmWeituoYangpinService.save(itdmWeituoYangpin);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param itdmWeituoYangpin
	 * @return
	 */
	@AutoLog(value = "委托样品-编辑")
	@ApiOperation(value="委托样品-编辑", notes="委托样品-编辑")
	//@RequiresPermissions("org.jeecg.modules:itdm_weituo_yangpin:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ItdmWeituoYangpin itdmWeituoYangpin) {
		itdmWeituoYangpinService.updateById(itdmWeituoYangpin);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "委托样品-通过id删除")
	@ApiOperation(value="委托样品-通过id删除", notes="委托样品-通过id删除")
	//@RequiresPermissions("org.jeecg.modules:itdm_weituo_yangpin:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		itdmWeituoYangpinService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "委托样品-批量删除")
	@ApiOperation(value="委托样品-批量删除", notes="委托样品-批量删除")
	//@RequiresPermissions("org.jeecg.modules:itdm_weituo_yangpin:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.itdmWeituoYangpinService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "委托样品-通过id查询")
	@ApiOperation(value="委托样品-通过id查询", notes="委托样品-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ItdmWeituoYangpin> queryById(@RequestParam(name="id",required=true) String id) {
		ItdmWeituoYangpin itdmWeituoYangpin = itdmWeituoYangpinService.getById(id);
		if(itdmWeituoYangpin==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(itdmWeituoYangpin);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param itdmWeituoYangpin
    */
    //@RequiresPermissions("org.jeecg.modules:itdm_weituo_yangpin:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ItdmWeituoYangpin itdmWeituoYangpin) {
        return super.exportXls(request, itdmWeituoYangpin, ItdmWeituoYangpin.class, "委托样品");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("itdm_weituo_yangpin:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ItdmWeituoYangpin.class);
    }

}
